
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/Graphics/SVG/SVG-19990812.dtd"
                xmlns:java="http://xml.apache.org/xalan/java" >
<xsl:output method="text" />


<xsl:template match="/">

		<xsl:variable name="nbgen" select="count(descendant::generation)" />


http://chart.apis.google.com/chart
  ?chxl=1:|Generation|3:|Fitness
  &#38;chxp=1,5|3,100
  &#38;chxr=0,0,<xsl:value-of select="$nbgen" />,1|1,0,5
  &#38;chxs=0,676767,11.5,0,lt,676767
  &#38;chxt=x,x,y,y
  &#38;chs=500x500
  &#38;cht=lc
  &#38;chco=3D7930,FF9900,FF0000
  &#38;chd=t:<xsl:apply-templates select="descendant::generation" mode="moyenne" ><xsl:with-param name="nbgen" select="$nbgen" /></xsl:apply-templates>|<xsl:apply-templates select="descendant::generation" mode="best" ><xsl:with-param name="nbgen" select="$nbgen" /></xsl:apply-templates>|<xsl:apply-templates select="descendant::generation" mode="mediane" ><xsl:with-param name="nbgen" select="$nbgen" /></xsl:apply-templates> 
  &#38;chdl=medium+fitness|best+fitness|mediane+fitness   
  &#38;chg=<xsl:value-of select="format-number( 100 div ($nbgen),'#.###')" />,5,0,0
  &#38;chls=2,4,0
  &#38;chtt=Evolution+of+Fitness+with+generation


</xsl:template>

<xsl:template match="generation" mode="mediane"  >
	<xsl:param name="nbgen" />
	<xsl:apply-templates select="descendant::individual" mode="mediane"/>
	<xsl:value-of select="java:Fitness.getMediane()"/>	
 	<xsl:if test="position() &lt; $nbgen">,</xsl:if>
</xsl:template>

<xsl:template match="generation" mode="moyenne" >
	<xsl:param name="nbgen" />
    <xsl:variable name="nbindiv" select="count(descendant::individual)" />
	<xsl:value-of select="format-number( sum(descendant::individual/@fitness) div $nbindiv,'#.###')"/>	
 	<xsl:if test="position() &lt; $nbgen ">,</xsl:if>
</xsl:template>

<xsl:template match="generation" mode="best" >
	<xsl:param name="nbgen" />
	<xsl:apply-templates select="descendant::individual" mode="somme" />
	<xsl:value-of select="java:Fitness.getBest()"/>	
 	<xsl:if test="position() &lt; $nbgen ">,</xsl:if>
</xsl:template>


<xsl:template match="individual" mode="somme" >
	 <xsl:value-of select="java:Fitness.Sum(@fitness,@id)"/>	
</xsl:template>

<xsl:template match="individual" mode="mediane" >
	 <xsl:value-of select="java:Fitness.Mediane(@fitness)"/>	
</xsl:template>

</xsl:stylesheet>
